Index: /palm/trunk/SOURCE/init_pt_anomaly.f90
===================================================================
--- /palm/trunk/SOURCE/init_pt_anomaly.f90	(revision 1319)
+++ /palm/trunk/SOURCE/init_pt_anomaly.f90	(revision 1320)
@@ -20,5 +20,10 @@
 ! Current revisions:
 ! -----------------
-!
+! ONLY-attribute added to USE-statements,
+! kind-parameters added to all INTEGER and REAL declaration statements,
+! kinds are defined in new module kinds,
+! revision history before 2012 removed,
+! comment fields (!:) to be used for variable explanations added to
+! all variable declaration statements
 !
 ! Former revisions:
@@ -32,19 +37,4 @@
 ! Modification of the amplitude to obtain a visible temperature perturbation.
 !
-! 667 2010-12-23 12:06:00Z suehring/gryschka
-! Call of exchange_horiz are modified.
-!
-! 75 2007-03-22 09:54:05Z raasch
-! 2nd+3rd argument removed from exchange horiz
-!
-! 19 2007-02-23 04:53:48Z raasch
-! Calculation extended for gridpoint nzt
-!
-! RCS Log replace by Id keyword, revision history cleaned up
-!
-! Revision 1.7  2005/03/26 20:36:55  raasch
-! Arguments for non-cyclic boundary conditions added to argument list of
-! routine exchange_horiz
-!
 ! Revision 1.1  1997/08/29 08:58:56  raasch
 ! Initial revision
@@ -56,15 +46,31 @@
 !------------------------------------------------------------------------------!
 
-    USE arrays_3d
-    USE constants
-    USE grid_variables
-    USE indices
-    USE control_parameters
+    USE arrays_3d,                                                             &
+        ONLY:  pt, zu
+
+    USE grid_variables,                                                        &
+        ONLY:  dx, dy
+
+    USE indices,                                                               &
+        ONLY:  nbgp, nx, nxl, nxr, nyn, nys, nzb, nzt
+        
+    USE kinds
 
     IMPLICIT NONE
 
-    INTEGER ::  i, ic, j, jc, k, kc
-    REAL    ::  betrag, radius, rc, x, y, z
-
+    INTEGER(iwp) ::  i  !:
+    INTEGER(iwp) ::  ic !:
+    INTEGER(iwp) ::  j  !:
+    INTEGER(iwp) ::  jc !:
+    INTEGER(iwp) ::  k  !:
+    INTEGER(iwp) ::  kc !:
+    
+    REAL(wp)     ::  betrag !:
+    REAL(wp)     ::  radius !:
+    REAL(wp)     ::  rc     !:
+    REAL(wp)     ::  x      !:
+    REAL(wp)     ::  y      !:
+    REAL(wp)     ::  z      !:
+    
 !
 !-- Defaults: radius rc, strength z,
Index: /palm/trunk/SOURCE/init_rankine.f90
===================================================================
--- /palm/trunk/SOURCE/init_rankine.f90	(revision 1319)
+++ /palm/trunk/SOURCE/init_rankine.f90	(revision 1320)
@@ -20,4 +20,10 @@
 ! Current revisions:
 ! -----------------
+! ONLY-attribute added to USE-statements,
+! kind-parameters added to all INTEGER and REAL declaration statements,
+! kinds are defined in new module kinds,
+! revision history before 2012 removed,
+! comment fields (!:) to be used for variable explanations added to
+! all variable declaration statements
 !
 ! Former revisions:
@@ -27,20 +33,4 @@
 ! 1036 2012-10-22 13:43:42Z raasch
 ! code put under GPL (PALM 3.9)
-!
-! 667 2010-12-23 12:06:00Z suehring/gryschka
-! nxl-1, nxr+1, nys-1, nyn+1 replaced by nxlg, nxrg, nysg, nyng. 
-! Calls of exchange_horiz are modified.
-!
-! 107 2007-08-17 13:54:45Z raasch
-! Initial profiles are reset to constant profiles
-!
-! 75 2007-03-22 09:54:05Z raasch
-! uxrp, vynp eliminated, 2nd+3rd argument removed from exchange horiz
-!
-! RCS Log replace by Id keyword, revision history cleaned up
-!
-! Revision 1.11  2005/03/26 20:38:49  raasch
-! Arguments for non-cyclic boundary conditions added to argument list of
-! routine exchange_horiz
 !
 ! Revision 1.1  1997/08/11 06:18:43  raasch
@@ -54,14 +44,39 @@
 !------------------------------------------------------------------------------!
 
-    USE arrays_3d
-    USE constants
-    USE grid_variables
-    USE indices
-    USE control_parameters
+    USE arrays_3d,                                                             &
+        ONLY:  pt, pt_init, u, u_init, v, v_init
+
+    USE control_parameters,                                                    &
+        ONLY:  initializing_actions, n_sor, nsor, nsor_ini   
+
+    USE constants,                                                             &
+        ONLY:  pi
+
+    USE grid_variables,                                                        &
+        ONLY:  dx, dy 
+
+    USE indices,                                                               &
+        ONLY:  nbgp, nx, nxl, nxlg, nxr, nxrg, nyn, nyng, nys, nysg, nzb, nzt     
+                
+    USE kinds
 
     IMPLICIT NONE
 
-    INTEGER ::  i, ic, j, jc, k, kc1, kc2
-    REAL    ::  alpha, betrag, radius, rc, uw, vw, x, y
+    INTEGER(iwp) ::  i   !:
+    INTEGER(iwp) ::  ic  !:
+    INTEGER(iwp) ::  j   !:
+    INTEGER(iwp) ::  jc  !:
+    INTEGER(iwp) ::  k   !:
+    INTEGER(iwp) ::  kc1 !:
+    INTEGER(iwp) ::  kc2 !:
+    
+    REAL(wp)     ::  alpha  !:
+    REAL(wp)     ::  betrag !:
+    REAL(wp)     ::  radius !:
+    REAL(wp)     ::  rc     !:
+    REAL(wp)     ::  uw     !:
+    REAL(wp)     ::  vw     !:
+    REAL(wp)     ::  x      !:
+    REAL(wp)     ::  y      !:
 
 !
Index: /palm/trunk/SOURCE/init_slope.f90
===================================================================
--- /palm/trunk/SOURCE/init_slope.f90	(revision 1319)
+++ /palm/trunk/SOURCE/init_slope.f90	(revision 1320)
@@ -20,4 +20,10 @@
 ! Current revisions:
 ! -----------------
+! ONLY-attribute added to USE-statements,
+! kind-parameters added to all INTEGER and REAL declaration statements,
+! kinds are defined in new module kinds,
+! revision history before 2012 removed,
+! comment fields (!:) to be used for variable explanations added to
+! all variable declaration statements
 !
 ! Former revisions:
@@ -27,16 +33,4 @@
 ! 1036 2012-10-22 13:43:42Z raasch
 ! code put under GPL (PALM 3.9)
-!
-! 667 2010-12-23 12:06:00Z suehring/gryschka
-! nxl-1, nxr+1, nys-1, nyn+1 replaced by nxlg, nxrg, nysg, nyng.
-!
-! 622 2010-12-10 08:08:13Z raasch
-! optional barriers included in order to speed up collective operations
-!
-! Feb. 2007
-! RCS Log replace by Id keyword, revision history cleaned up
-!
-! Revision 1.5  2006/02/23 12:35:34  raasch
-! nanz_2dh renamed ngp_2dh
 !
 ! Revision 1.1  2000/04/27 07:06:24  raasch
@@ -52,16 +46,37 @@
 !------------------------------------------------------------------------------!
 
-    USE arrays_3d
-    USE constants
-    USE grid_variables
-    USE indices
+    USE arrays_3d,                                                             &
+        ONLY:  pt, pt_init, pt_slope_ref, zu
+        
+    USE constants,                                                             &
+        ONLY:  pi
+                    
+    USE control_parameters,                                                    &
+        ONLY:  alpha_surface, initializing_actions, pt_slope_offset,           &
+               pt_surface, pt_vertical_gradient, sin_alpha_surface
+        
+    USE grid_variables,                                                        &
+        ONLY:  dx
+        
+    USE indices,                                                               &
+        ONLY:  ngp_2dh, nx, nxl, nxlg, nxr, nxrg, nyn, nyng, nys, nysg, nzb, nzt
+        
+    USE kinds
+
     USE pegrid
-    USE control_parameters
+
 
     IMPLICIT NONE
 
-    INTEGER ::  i, j, k
-    REAL    ::  alpha, height, pt_value, radius
-    REAL, DIMENSION(:), ALLOCATABLE ::  pt_init_local
+    INTEGER(iwp) ::  i        !:
+    INTEGER(iwp) ::  j        !:
+    INTEGER(iwp) ::  k        !:
+    
+    REAL(wp)     ::  alpha    !:
+    REAL(wp)     ::  height   !:
+    REAL(wp)     ::  pt_value !:
+    REAL(wp)     ::  radius   !:
+    
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  pt_init_local !:
 
 !
Index: /palm/trunk/SOURCE/interaction_droplets_ptq.f90
===================================================================
--- /palm/trunk/SOURCE/interaction_droplets_ptq.f90	(revision 1319)
+++ /palm/trunk/SOURCE/interaction_droplets_ptq.f90	(revision 1320)
@@ -60,8 +60,14 @@
     SUBROUTINE interaction_droplets_ptq
 
-       USE arrays_3d
-       USE cloud_parameters
-       USE control_parameters
-       USE indices
+       USE arrays_3d,                                                          &
+           ONLY:  pt_p, ql_c, q_p
+           
+       USE cloud_parameters,                                                   &
+           ONLY:  l_d_cp, pt_d_t
+           
+       USE indices,                                                            &
+           ONLY:  nxl, nxr, nyn, nys, nzb_2d, nzt
+           
+       USE kinds
 
        USE pegrid
@@ -69,5 +75,7 @@
        IMPLICIT NONE
 
-       INTEGER ::  i, j, k
+       INTEGER(iwp) ::  i !:
+       INTEGER(iwp) ::  j !:
+       INTEGER(iwp) ::  k !:
 
  
@@ -89,8 +97,15 @@
     SUBROUTINE interaction_droplets_ptq_ij( i, j )
 
-       USE arrays_3d
-       USE cloud_parameters
-       USE control_parameters
-       USE indices
+       USE arrays_3d,                                                          &
+           ONLY:  pt_p, ql_c, q_p
+
+       USE cloud_parameters,                                                   &
+           ONLY:  l_d_cp, pt_d_t
+
+       USE indices,                                                            &
+           ONLY:  nxl, nxr, nyn, nys, nzb_2d, nzt
+
+       USE kinds,                                                              &
+           ONLY:  iwp, wp
 
        USE pegrid
@@ -98,5 +113,7 @@
        IMPLICIT NONE
 
-       INTEGER ::  i, j, k
+       INTEGER(iwp) ::  i !:
+       INTEGER(iwp) ::  j !:
+       INTEGER(iwp) ::  k !:
 
 
Index: /palm/trunk/SOURCE/local_flush.f90
===================================================================
--- /palm/trunk/SOURCE/local_flush.f90	(revision 1319)
+++ /palm/trunk/SOURCE/local_flush.f90	(revision 1320)
@@ -20,5 +20,8 @@
 ! Current revisions:
 ! -----------------
-! 
+! kind-parameters added to all INTEGER and REAL declaration statements,
+! kinds are defined in new module kinds,
+! comment fields (!:) to be used for variable explanations added to
+! all variable declaration statements
 !
 ! Former revisions:
@@ -37,5 +40,7 @@
 !------------------------------------------------------------------------------!
 
-    INTEGER ::  file_id
+    USE kinds
+
+    INTEGER(iwp) ::  file_id !:
 
 #if defined( __ibm )
Index: /palm/trunk/SOURCE/local_getenv.f90
===================================================================
--- /palm/trunk/SOURCE/local_getenv.f90	(revision 1319)
+++ /palm/trunk/SOURCE/local_getenv.f90	(revision 1320)
@@ -20,5 +20,10 @@
 ! Current revisions:
 ! -----------------
-! 
+! ONLY-attribute added to USE-statements,
+! kind-parameters added to all INTEGER and REAL declaration statements,
+! kinds are defined in new module kinds,
+! revision history before 2012 removed,
+! comment fields (!:) to be used for variable explanations added to
+! all variable declaration statements 
 !
 ! Former revisions:
@@ -28,13 +33,4 @@
 ! 1036 2012-10-22 13:43:42Z raasch
 ! code put under GPL (PALM 3.9)
-!
-! 82 2007-04-16 15:40:52Z raasch
-! Preprocessor directives for old systems removed
-!
-! RCS Log replace by Id keyword, revision history cleaned up
-!
-! Revision 1.5  2003/05/09 14:37:07  raasch
-! On the MUK cluster, only PE0 is able to read environment variables.
-! Therefore, they have to be communicated via broadcast to the other PEs.
 !
 ! Revision 1.1  1997/08/11 06:21:01  raasch
@@ -47,11 +43,17 @@
 !------------------------------------------------------------------------------!
 
+    USE kinds
+        
 #if defined( __lcmuk )
     USE pegrid
 #endif
-    CHARACTER (LEN=*) ::  var, value
-    INTEGER           ::  ivalue, ivar
+    CHARACTER (LEN=*) ::  value  !:
+    CHARACTER (LEN=*) ::  var    !:
+    
+    INTEGER(iwp)      ::  ivalue !:
+    INTEGER(iwp)      ::  ivar   !:
 #if defined( __lcmuk )
-    INTEGER            ::  i, ia(20)
+    INTEGER(iwp)      ::  i      !:
+    INTEGER(iwp)      ::  ia(20) !:
 #endif
 
Index: /palm/trunk/SOURCE/local_stop.f90
===================================================================
--- /palm/trunk/SOURCE/local_stop.f90	(revision 1319)
+++ /palm/trunk/SOURCE/local_stop.f90	(revision 1320)
@@ -20,5 +20,6 @@
 ! Current revisions:
 ! -----------------
-!
+! ONLY-attribute added to USE-statements,
+! revision history before 2012 removed,
 !
 ! Former revisions:
@@ -35,23 +36,4 @@
 ! New cpp directive "__check" implemented which is used by check_namelist_files
 !
-! 667 2010-12-23 12:06:00Z suehring/gryschka
-! Exchange of terminate_coupled between ocean and atmosphere via PE0
-!
-! 213 2008-11-13 10:26:18Z raasch
-! Implementation of a MPI-1 coupling: replaced myid with target_id.
-! The uncoupled case allows stop or mpi_abort depending on new steering
-! parameter abort_mode, which is set in routine message.
-!
-! 147 2008-02-01 12:41:46Z raasch
-! Bugfix: a stop command was missing in some cases of the parallel branch
-!
-! 108 2007-08-24 15:10:38Z letzel
-! modifications to terminate coupled runs
-!
-! RCS Log replace by Id keyword, revision history cleaned up
-!
-! Revision 1.2  2003/03/16 09:40:28  raasch
-! Two underscores (_) are placed in front of all define-strings
-!
 ! Revision 1.1  2002/12/19 15:46:23  raasch
 ! Initial revision
@@ -64,5 +46,9 @@
 
     USE pegrid
-    USE control_parameters
+    
+    USE control_parameters,                                                    &
+        ONLY:  abort_mode, coupling_mode, coupling_mode_remote, dt_restart,    &
+               stop_dt, terminate_coupled, terminate_coupled_remote,           &
+               terminate_run, time_restart
 
 
Index: /palm/trunk/SOURCE/local_system.f90
===================================================================
--- /palm/trunk/SOURCE/local_system.f90	(revision 1319)
+++ /palm/trunk/SOURCE/local_system.f90	(revision 1320)
@@ -20,5 +20,7 @@
 ! Current revisions:
 ! -----------------
-! 
+! revision history before 2012 removed,
+! comment fields (!:) to be used for variable explanations added to
+! all variable declaration statements
 !
 ! Former revisions:
@@ -28,12 +30,4 @@
 ! 1036 2012-10-22 13:43:42Z raasch
 ! code put under GPL (PALM 3.9)
-!
-! 82 2007-04-16 15:40:52Z raasch
-! Preprocessor directives for old systems removed
-!
-! RCS Log replace by Id keyword, revision history cleaned up
-!
-! Revision 1.4  2003/03/16 09:40:33  raasch
-! Two underscores (_) are placed in front of all define-strings
 !
 ! Revision 1.1  1997/09/03 06:27:27  raasch
@@ -46,5 +40,5 @@
 !------------------------------------------------------------------------------!
 
-    CHARACTER (LEN=*) ::  command
+    CHARACTER (LEN=*) ::  command !:
 
     CALL SYSTEM( command )
Index: /palm/trunk/SOURCE/local_tremain.f90
===================================================================
--- /palm/trunk/SOURCE/local_tremain.f90	(revision 1319)
+++ /palm/trunk/SOURCE/local_tremain.f90	(revision 1320)
@@ -20,5 +20,10 @@
 ! Current revisions:
 ! -----------------
-! 
+! ONLY-attribute added to USE-statements,
+! kind-parameters added to all INTEGER and REAL declaration statements,
+! kinds are defined in new module kinds,
+! revision history before 2012 removed,
+! comment fields (!:) to be used for variable explanations added to
+! all variable declaration statements
 !
 ! Former revisions:
@@ -28,17 +33,4 @@
 ! 1036 2012-10-22 13:43:42Z raasch
 ! code put under GPL (PALM 3.9)
-!
-! 225 2009-01-26 14:44:20Z raasch
-! Type of count and count_rate changed to INTEGER(8) in order to avoid out of
-! range problems (which result in measured negative time intervals)
-!
-! 82 2007-04-16 15:40:52Z raasch
-! Preprocessor strings for different linux clusters changed to "lc",
-! preprocessor directives for old systems removed
-!
-! RCS Log replace by Id keyword, revision history cleaned up
-!
-! Revision 1.14  2006/06/02 15:20:33  raasch
-! Extended to TIT Sun Fire X4600 System (lctit)
 !
 ! Revision 1.1  1998/03/18 20:14:47  raasch
@@ -51,17 +43,24 @@
 !------------------------------------------------------------------------------!
 
-    USE control_parameters
-    USE cpulog
+    USE control_parameters,                                                    &
+        ONLY:  maximum_cpu_time_allowed
+
+    USE cpulog,                                                                &
+        ONLY:  initial_wallclock_time
+
+    USE kinds
+
     USE pegrid
 
     IMPLICIT NONE
 
-    REAL ::  remaining_time
+    REAL(wp)     ::  remaining_time        !:
 #if defined( __ibm )
-    INTEGER(8) ::  IRTC
-    REAL       ::  actual_wallclock_time
+    INTEGER(idp) ::  IRTC                  !:
+    REAL(wp)     ::  actual_wallclock_time !:
 #elif defined( __lc )
-    INTEGER(8) ::  count, count_rate
-    REAL       ::  actual_wallclock_time
+    INTEGER(idp) ::  count                 !:
+    INTEGER(idp) ::  count_rate            !:
+    REAL(wp)     ::  actual_wallclock_time !:
 #endif
 
Index: /palm/trunk/SOURCE/local_tremain_ini.f90
===================================================================
--- /palm/trunk/SOURCE/local_tremain_ini.f90	(revision 1319)
+++ /palm/trunk/SOURCE/local_tremain_ini.f90	(revision 1320)
@@ -20,5 +20,10 @@
 ! Current revisions:
 ! -----------------
-! 
+! ONLY-attribute added to USE-statements,
+! kind-parameters added to all INTEGER and REAL declaration statements,
+! kinds are defined in new module kinds,
+! revision history before 2012 removed,
+! comment fields (!:) to be used for variable explanations added to
+! all variable declaration statements
 !
 ! Former revisions:
@@ -32,17 +37,4 @@
 ! code put under GPL (PALM 3.9)
 !
-! 225 2009-01-26 14:44:20Z raasch
-! Type of count and count_rate changed to INTEGER(8) in order to avoid out of
-! range problems (which result in measured negative time intervals)
-!
-! 82 2007-04-16 15:40:52Z raasch
-! Cpp-directive lctit renamed lc
-!
-! RCS Log replace by Id keyword, revision history cleaned up
-!
-! Revision 1.13  2007/02/11 13:07:03  raasch
-! Allowed cpu limit is now read from file instead of reading the value from
-! environment variable (see routine parin)
-!
 ! Revision 1.1  1998/03/18 20:15:05  raasch
 ! Initial revision
@@ -53,14 +45,17 @@
 ! Initialization of CPU-time measurements for different operating systems
 !------------------------------------------------------------------------------!
-
-    USE control_parameters
-    USE cpulog
+      
+    USE cpulog,                                                                &
+        ONLY:  initial_wallclock_time
+        
+    USE kinds
 
     IMPLICIT NONE
 
 #if defined( __ibm )
-    INTEGER(8)         ::  IRTC
+    INTEGER(idp)     ::  IRTC       !:
 #elif defined( __lc )
-    INTEGER(8)         ::  count, count_rate
+    INTEGER(idp)     ::  count      !:
+    INTEGER(idp)     ::  count_rate !:
 #endif
 
Index: /palm/trunk/SOURCE/lpm.f90
===================================================================
--- /palm/trunk/SOURCE/lpm.f90	(revision 1319)
+++ /palm/trunk/SOURCE/lpm.f90	(revision 1320)
@@ -20,5 +20,10 @@
 ! Current revisions:
 ! ------------------
-!
+! ONLY-attribute added to USE-statements,
+! kind-parameters added to all INTEGER and REAL declaration statements,
+! kinds are defined in new module kinds,
+! revision history before 2012 removed,
+! comment fields (!:) to be used for variable explanations added to
+! all variable declaration statements
 !
 ! Former revisions:
@@ -59,14 +64,4 @@
 ! wang_collision_kernel renamed wang_kernel
 !
-! 799 2011-12-21 17:48:03Z franke
-! Implementation of Wang collision kernel and corresponding new parameter 
-! wang_collision_kernel
-!
-! 792 2011-12-01 raasch
-! particle arrays (particles, particles_temp) implemented as pointers in
-! order to speed up sorting (see routine sort_particles)
-!
-! 759 2011-09-15 13:58:31Z raasch
-! Splitting of parallel I/O (routine write_particles)
 !
 ! Revision 1.1  1999/11/25 16:16:06  raasch
@@ -79,14 +74,32 @@
 !------------------------------------------------------------------------------!
 
-    USE arrays_3d
-    USE control_parameters
-    USE cpulog
-    USE particle_attributes
+    USE arrays_3d,                                                             &
+        ONLY:  ql_c, ql_v, ql_vp
+
+    USE control_parameters,                                                    &
+        ONLY:  cloud_droplets, dt_3d, dt_3d_reached, dt_3d_reached_l,          &
+               molecular_viscosity, simulated_time
+
+    USE cpulog,                                                                &
+        ONLY:  cpu_log, log_point, log_point_s
+
+    USE kinds
+
+    USE particle_attributes,                                                   &
+        ONLY:  collision_kernel, deleted_particles, dt_sort_particles,         &
+               deleted_tails, dt_write_particle_data, dt_prel, end_time_prel,  &
+               number_of_particles, number_of_particle_groups,particles,       &
+               particle_groups, particle_mask, trlp_count_sum, tail_mask,      &
+               time_prel, time_sort_particles, time_write_particle_data,       &
+               trlp_count_recv_sum, trnp_count_sum, trnp_count_recv_sum,       &
+               trrp_count_sum, trrp_count_recv_sum, trsp_count_sum,            &
+               trsp_count_recv_sum, use_particle_tails, use_sgs_for_particles, &
+               write_particle_statistics
+
     USE pegrid
-    USE statistics
 
     IMPLICIT NONE
 
-    INTEGER ::  m
+    INTEGER(iwp) ::  m                       !:
 
 
Index: /palm/trunk/SOURCE/lpm_advec.f90
===================================================================
--- /palm/trunk/SOURCE/lpm_advec.f90	(revision 1319)
+++ /palm/trunk/SOURCE/lpm_advec.f90	(revision 1320)
@@ -20,5 +20,10 @@
 ! Current revisions:
 ! ------------------
-!
+! ONLY-attribute added to USE-statements,
+! kind-parameters added to all INTEGER and REAL declaration statements,
+! kinds are defined in new module kinds,
+! revision history before 2012 removed,
+! comment fields (!:) to be used for variable explanations added to
+! all variable declaration statements
 !
 ! Former revisions:
@@ -44,33 +49,101 @@
 !------------------------------------------------------------------------------!
 
-    USE arrays_3d
-    USE control_parameters
-    USE grid_variables
-    USE indices
-    USE particle_attributes
-    USE statistics
+    USE arrays_3d,                                                             &
+        ONLY:  de_dx, de_dy, de_dz, diss, e, u, us, usws, v, vsws, w, z0, zu, zw
+
+    USE control_parameters,                                                    &
+        ONLY:  atmos_ocean_sign, cloud_droplets, dt_3d, dt_3d_reached_l, dz,   &
+               g, kappa, molecular_viscosity, prandtl_layer, topography,       &
+               u_gtrans, v_gtrans
+
+    USE grid_variables,                                                        &
+        ONLY:  ddx, dx, ddy, dy
+        
+    USE indices,                                                               &
+        ONLY:  nzb, nzb_s_inner, nzt
+        
+    USE kinds
+    
+    USE particle_attributes,                                                   &
+        ONLY:  c_0, density_ratio, dt_min_part, iran_part, log_z_z0,           &
+               number_of_particles, number_of_sublayers, particles,            &
+               particle_groups, offset_ocean_nzt, offset_ocean_nzt_m1,         &
+               sgs_wfu_part, sgs_wfv_part, sgs_wfw_part, use_sgs_for_particles,&
+               vertical_particle_advection, z0_av_global
+        
+    USE statistics,                                                            &
+        ONLY:  hom
+        
 
     IMPLICIT NONE
 
-    INTEGER ::  i, j, k, n
-
-    REAL ::  aa, bb, cc, dd, dens_ratio, exp_arg, exp_term, gg, u_int,  &
-             u_int_l, u_int_u, v_int, v_int_l, v_int_u, w_int, w_int_l, &
-             w_int_u, x, y
-
-
-    INTEGER ::  agp, kw, num_gp
-    INTEGER ::  gp_outside_of_building(1:8)
-
-    REAL ::  d_sum, de_dx_int, de_dx_int_l, de_dx_int_u, de_dy_int,       &
-             de_dy_int_l, de_dy_int_u, de_dt, de_dt_min, de_dz_int,       &
-             de_dz_int_l, de_dz_int_u, diss_int, diss_int_l, diss_int_u,  &
-             dt_gap, dt_particle, dt_particle_m, e_int, e_int_l, e_int_u, &
-             e_mean_int, fs_int, lagr_timescale, random_gauss, vv_int
-
-    REAL ::    height_int, height_p, log_z_z0_int, us_int, z_p, d_z_p_z0
-
-    REAL ::  location(1:30,1:3)
-    REAL, DIMENSION(1:30) ::  de_dxi, de_dyi, de_dzi, dissi, d_gp_pl, ei
+    INTEGER(iwp) ::  agp                         !:
+    INTEGER(iwp) ::  gp_outside_of_building(1:8) !:
+    INTEGER(iwp) ::  i                           !:
+    INTEGER(iwp) ::  j                           !:
+    INTEGER(iwp) ::  k                           !:
+    INTEGER(iwp) ::  kw                          !:
+    INTEGER(iwp) ::  n                           !:
+    INTEGER(iwp) ::  num_gp                      !:
+
+    REAL(wp) ::  aa                 !:
+    REAL(wp) ::  bb                 !:
+    REAL(wp) ::  cc                 !:
+    REAL(wp) ::  d_sum              !:
+    REAL(wp) ::  d_z_p_z0           !:
+    REAL(wp) ::  dd                 !:
+    REAL(wp) ::  de_dx_int          !:
+    REAL(wp) ::  de_dx_int_l        !:
+    REAL(wp) ::  de_dx_int_u        !:
+    REAL(wp) ::  de_dy_int          !:
+    REAL(wp) ::  de_dy_int_l        !:
+    REAL(wp) ::  de_dy_int_u        !:
+    REAL(wp) ::  de_dt              !:
+    REAL(wp) ::  de_dt_min          !:
+    REAL(wp) ::  de_dz_int          !:
+    REAL(wp) ::  de_dz_int_l        !:
+    REAL(wp) ::  de_dz_int_u        !:
+    REAL(wp) ::  dens_ratio         !:
+    REAL(wp) ::  diss_int           !:
+    REAL(wp) ::  diss_int_l         !:
+    REAL(wp) ::  diss_int_u         !:
+    REAL(wp) ::  dt_gap             !:
+    REAL(wp) ::  dt_particle        !:
+    REAL(wp) ::  dt_particle_m      !:
+    REAL(wp) ::  e_int              !:
+    REAL(wp) ::  e_int_l            !:
+    REAL(wp) ::  e_int_u            !:
+    REAL(wp) ::  e_mean_int         !:
+    REAL(wp) ::  exp_arg            !:
+    REAL(wp) ::  exp_term           !:
+    REAL(wp) ::  fs_int             !:
+    REAL(wp) ::  gg                 !:
+    REAL(wp) ::  height_int         !:
+    REAL(wp) ::  height_p           !:
+    REAL(wp) ::  lagr_timescale     !:
+    REAL(wp) ::  location(1:30,1:3) !:
+    REAL(wp) ::  log_z_z0_int       !:
+    REAL(wp) ::  random_gauss       !:
+    REAL(wp) ::  u_int              !:
+    REAL(wp) ::  u_int_l            !:
+    REAL(wp) ::  u_int_u            !:
+    REAL(wp) ::  us_int             !:
+    REAL(wp) ::  v_int              !:
+    REAL(wp) ::  v_int_l            !:
+    REAL(wp) ::  v_int_u            !:
+    REAL(wp) ::  vv_int             !:
+    REAL(wp) ::  w_int              !:
+    REAL(wp) ::  w_int_l            !:
+    REAL(wp) ::  w_int_u            !:
+    REAL(wp) ::  x                  !:
+    REAL(wp) ::  y                  !:
+    REAL(wp) ::  z_p                !:    
+
+    REAL(wp), DIMENSION(1:30) ::  d_gp_pl !:
+    REAL(wp), DIMENSION(1:30) ::  de_dxi  !:
+    REAL(wp), DIMENSION(1:30) ::  de_dyi  !:
+    REAL(wp), DIMENSION(1:30) ::  de_dzi  !:
+    REAL(wp), DIMENSION(1:30) ::  dissi   !:
+    REAL(wp), DIMENSION(1:30) ::  ei      !:
 
 !
Index: /palm/trunk/SOURCE/lpm_boundary_conds.f90
===================================================================
--- /palm/trunk/SOURCE/lpm_boundary_conds.f90	(revision 1319)
+++ /palm/trunk/SOURCE/lpm_boundary_conds.f90	(revision 1320)
@@ -20,5 +20,10 @@
 ! Current revisions:
 ! -----------------
-!
+! ONLY-attribute added to USE-statements,
+! kind-parameters added to all INTEGER and REAL declaration statements,
+! kinds are defined in new module kinds,
+! revision history before 2012 removed,
+! comment fields (!:) to be used for variable explanations added to
+! all variable declaration statements
 !
 ! Former revisions:
@@ -26,7 +31,4 @@
 ! $Id$
 !
-! 1318 2014-03-17 13:35:16Z raasch
-! module interfaces removed
-!
 ! 1036 2012-10-22 13:43:42Z raasch
 ! code put under GPL (PALM 3.9)
@@ -38,7 +40,4 @@
 ! 824 2012-02-17 09:09:57Z raasch
 ! particle attributes speed_x|y|z_sgs renamed rvar1|2|3
-!
-! 150 2008-02-29 08:19:58Z raasch
-! Vertical index calculations adjusted for ocean runs.
 !
 ! Initial version (2007/03/09)
@@ -61,27 +60,75 @@
 !------------------------------------------------------------------------------!
 
-    USE arrays_3d
-    USE control_parameters
-    USE cpulog
-    USE grid_variables
-    USE indices
-    USE particle_attributes
+    USE arrays_3d,                                                             &
+        ONLY:  zu, zw
+
+    USE control_parameters,                                                    &
+        ONLY:  dz, message_string, particle_maximum_age
+
+    USE cpulog,                                                                &
+        ONLY:  cpu_log, log_point_s
+
+    USE grid_variables,                                                        &
+        ONLY:  ddx, dx, ddy, dy
+
+    USE indices,                                                               &
+        ONLY:  nxl, nxr, nyn, nys, nz, nzb_s_inner
+
+    USE kinds
+
+    USE particle_attributes,                                                   &
+        ONLY:  deleted_particles, deleted_tails, ibc_par_b, ibc_par_t,         &
+               number_of_particles, particles, particle_mask,                  &
+               particle_tail_coordinates, particle_type, offset_ocean_nzt_m1,  &
+               tail_mask, use_particle_tails, use_sgs_for_particles
+
     USE pegrid
 
     IMPLICIT NONE
 
-    CHARACTER (LEN=*) ::  range
-
-    INTEGER ::  i, inc, ir, i1, i2, i3, i5, j, jr, j1, j2, j3, j5, k, k1, k2, &
-                k3, k5, n, nn, t_index, t_index_number
-
-    LOGICAL ::  reflect_x, reflect_y, reflect_z
-
-    REAL ::  dt_particle, pos_x, pos_x_old, pos_y, pos_y_old, pos_z, &
-             pos_z_old, prt_x, prt_y, prt_z, tmp_t, xline, yline, zline
-
-    REAL ::  t(1:200)
-
-
+    CHARACTER (LEN=*) ::  range     !:
+    
+    INTEGER(iwp) ::  i              !:
+    INTEGER(iwp) ::  inc            !:
+    INTEGER(iwp) ::  ir             !:
+    INTEGER(iwp) ::  i1             !:
+    INTEGER(iwp) ::  i2             !:
+    INTEGER(iwp) ::  i3             !:
+    INTEGER(iwp) ::  i5             !:
+    INTEGER(iwp) ::  j              !:
+    INTEGER(iwp) ::  jr             !:
+    INTEGER(iwp) ::  j1             !:
+    INTEGER(iwp) ::  j2             !:
+    INTEGER(iwp) ::  j3             !:
+    INTEGER(iwp) ::  j5             !:
+    INTEGER(iwp) ::  k              !:
+    INTEGER(iwp) ::  k1             !:
+    INTEGER(iwp) ::  k2             !:
+    INTEGER(iwp) ::  k3             !:
+    INTEGER(iwp) ::  k5             !:
+    INTEGER(iwp) ::  n              !:
+    INTEGER(iwp) ::  nn             !:
+    INTEGER(iwp) ::  t_index        !:
+    INTEGER(iwp) ::  t_index_number !:
+    
+    LOGICAL  ::  reflect_x   !:
+    LOGICAL  ::  reflect_y   !:
+    LOGICAL  ::  reflect_z   !:
+
+    REAL(wp) ::  dt_particle !:
+    REAL(wp) ::  pos_x       !:
+    REAL(wp) ::  pos_x_old   !:
+    REAL(wp) ::  pos_y       !:
+    REAL(wp) ::  pos_y_old   !:
+    REAL(wp) ::  pos_z       !:
+    REAL(wp) ::  pos_z_old   !:
+    REAL(wp) ::  prt_x       !:
+    REAL(wp) ::  prt_y       !:
+    REAL(wp) ::  prt_z       !:
+    REAL(wp) ::  t(1:200)    !:
+    REAL(wp) ::  tmp_t       !:
+    REAL(wp) ::  xline       !:
+    REAL(wp) ::  yline       !:
+    REAL(wp) ::  zline       !:
 
     IF ( range == 'bottom/top' )  THEN
